#include "DEScrollWidget.H"

DScrollWidget::DScrollWidget(QPopupMenu* view = 0, int index = 0, QWidget * parent = 0, const char * name = 0, DPaintWindow* son):QScrollView(parent, name)
{
  //setGeometry(5, 15, parent->size().width()-10, parent->size().height()-20);
  _son = son;
  if (son) {
    addChild(son);
    setCaption(son->getName());
  }
  _view = view;
  _index = index;
  _name = new char[strlen(name) + 1];
  strcpy(_name,name);
  markedDeleted = 0;
}

char* DScrollWidget::getName() {
  return _name;
}

int DScrollWidget::getMarkedDeleted() {
  return markedDeleted;
}

void DScrollWidget::markDeleted() {
  markedDeleted = 1;
}

DScrollWidget::~DScrollWidget() {
  delete[] _name;
}

void DScrollWidget::setSon(DPaintWindow * son)
{
  if (!_son) {
    _son = son;
    addChild(son);
    setCaption(son->getName());
  }
}

void DScrollWidget::resizeEvent ( QResizeEvent * e )
{
    QScrollView::resizeEvent(e);
  if (_son) {
    _son->setGeometry(0,0,int(ceil((size().width()-4)*_son->getZoomFactor())), int(ceil((size().height()-4)*_son->getZoomFactor())));
    _son->repaint();
  }
}

void DScrollWidget::redoGeometryCalculations()
{
  //setGeometry(5, 15, size().width()-10, size().height()-20);
  //  repaint();
  if (_son) { 
    int temp1 = int(ceil((size().width()-4)*_son->getZoomFactor()));
    int temp2 = int(ceil((size().height()-4)*_son->getZoomFactor()));
    //I have no idea why I have to have this line in here twice, but if I don't and then do zoom in, scroll all the way to the right, and then zoom out, I get gray space on the leftt. I have no idea why repeating the following line twice fixes this problem - probably some ideosyncracy with QT.
    _son->setGeometry(0,0,temp1, temp2);
    _son->setGeometry(0,0,temp1, temp2);
    _son->repaint();
  }
}

void DScrollWidget::moveScrollBars(float ratio_x, float ratio_y) {
  horizontalScrollBar()->setValue(int(horizontalScrollBar()->maxValue() * ratio_x));
  verticalScrollBar()->setValue(int(verticalScrollBar()->maxValue() * ratio_y));
}

void DScrollWidget::setViewVals(QPopupMenu* view, int index)
{
  _view = view;
  _index = index;
}

bool DScrollWidget::close( bool alsoDelete ) {
  if (_view) {
    if (strcmp(_name,"ISOLATION")==0) {
      _view->removeItem(_index);
      markedDeleted = 1;
    }
    else if (_view->isItemChecked(_index)) 
      _view->setItemChecked(_index, false);
    return QWidget::close(alsoDelete);
  }
}

