//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Daniel Abadi
//  FILE: UsesList.H
//  PROJ: COKO DEBUGGER
//  DATE: SUMMER 2001                                                     
//
// SYNOPSIS
//  Classes for Uses List.
//  
//////////////////////////////////////////////////////////////////////////////


#ifndef _USESLIST_H_
#define _USESLIST_H_

#include <strings.h>
#include <stdlib.h>
#include "PCRule.H"
#include "PCRuleBlock.H"

class CRule;
class CRuleBlock;

class UsesNode
{
public:
  CRule * _rule;
  CRuleBlock * _ruleblock;
  UsesNode * _next;

  UsesNode(CRule * c);
  // Constructor

  UsesNode(CRuleBlock * c);
  // Constructor

  ~UsesNode();
  // Destructor

};

class UsesList
{
private:
  UsesNode * _iterator;
  UsesNode * _head;
  UsesNode * _tail;

public:

  UsesList();
  // Constructor
  
  ~UsesList();
  // Destructor

  void insert(CRule* a);
  //  Insert a new node with _rule = a to the list

  void insert(CRuleBlock* a);
  //  Insert a new node with _ruleblock = a to the list

  int pop();
  // Pop off a front node from the list
  // Return success value of the pop.

  CRule* topRule();
  // Returns _rule of the top node.

  CRuleBlock* topRuleBlock();
  // Returns _ruleblock of the top node.

  int empty();
  // Is the list empty?

  void initIterator();
  // Initialize _iterator
  // This method is used with getValue method

  CRule* iteratorRule();
  // Returns _rule of the node that _iterator is pointing to.

  CRuleBlock* iteratorRuleBlock();
  // Returns _ruleblock of the node that _iterator is pointing to.

  CRule* getValue();
  // Returns next _rule of the node that _iterator is pointing to.
  // After a call to this method, _iterator will point to the next node.
  // One can call this methods repeatly to get the _value of all the nodes.
  // However, initIterator has to be called before the initial call to this 
  // method.  

};

#endif

