//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon S. Lee (jl@cs.brown.edu)
//  FILE: PCFalseStmt.H
//  PROJ: COKO
//  DATE: 6/10/97                                                              
//
// SYNOPSIS
//  Class definition for CFalseStmt class.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCFALSESTMT_H_
#define _PCFALSESTMT_H_

#include <PCStmt.H>

//////////////////////////////////////////////////////////////////////////////
//
//  CLASS: CFalseStmt
//
// SYNOPSIS
//  This class is a derived class from CStmt. 
//  This stmt always returns false as a success value.
//
//////////////////////////////////////////////////////////////////////////////

class CFalseStmt : public CStmt
{
protected:
  CStmt *_stmt;                  
  // statement(s)

public:
  CFalseStmt(CStmt *); 
  // Constructor
  ~CFalseStmt(void);         
  // Destructor
  CState *Exec(CState *); 
  // What to do when executed


  //DJA SUMMER 2001:
  //Added rep_string, representation, number_self, output_self, is_leaf and ExecDebug methods

  char* rep_string ();
  //returns the string representation of only the current 
  //node of the COKO tree
  char* representation (int);
  //returns string representation of COKO tree
  char* representationWDI(int, DDebugController *);
  //returns string representation of COKO tree
  //but also update the debugger with the location (row and
  //column) of each breakable statement's substring
  CState *ExecDebug(CState *, DDebugController *);
  //what to do when executed in debug mode
  int number_self(int);
  //assigns an integer to the current node for use in the
  //debugger for the breakOptions command
  void output_self(DDebugController *db);
  //output key_number and rep_string for debugger
  //for breakOptions command
  int is_leaf();
  //returns whether current statement is a leaf in the COKO tree
  

};

#endif
