//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon-Suk Lee (jl)
//  FILE: PCGivenStmt.H
//  PROJ: COKO
//  DATE: 6/11/96                                                              
//
// SYNOPSIS
// Class definitions for CGivenStmt.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCGIVENSTMT_H_
#define _PCGIVENSTMT_H_
#define MAXARG 20

#include <stdarg.h>
#include "PCStmt.H"
#include "PCPattern.H"
#include "PCEqn.H"

//////////////////////////////////////////////////////////////////////////////
//
//  CLASS: CGivenStmt
//
// SYNOPSIS
//  This class is a derived class from CStmt. 
//  GivenStmt is consist of one or more equations.
//
//////////////////////////////////////////////////////////////////////////////

class CGivenStmt : public CStmt {
protected:
  CEqn* _eqnList[MAXARG];    
  // equation list

  CStmt *_stmt;
  // Given statement body

private:
  int _count;

public:
  CGivenStmt(CStmt* ... );                       
  // Constructor
  
  ~CGivenStmt();                      
  // Destructor
  
  CState *Exec(CState *);
  // What to do when executed


  //DJA SUMMER 2001:
  //Added rep_string, representation, number_self, output_self, is_leaf and ExecDebug methods

  char* rep_string ();
   //returns the string representation of only the current 
  //node of the COKO tree

  char* representation (int);
  //returns string representation of COKO tree

  char* representationWDI(int, DDebugController *);
  //returns string representation of COKO tree
  //but also update the debugger with the location (row and
  //column) of each breakable statement's substring

  CState *ExecDebug(CState *, DDebugController *);
  //what to do when executed in debug mode

  int number_self(int);
  //assigns an integer to the current node for use in the
  //debugger for the breakOptions command

  void output_self(DDebugController *db);
  //output key_number and rep_string for debugger
  //for breakOptions command
  
  int is_leaf();
  //returns whether current statement is a leaf in the COKO tree

};

#endif
