%{
#include <stdlib.h>
#include <string.h>
#include <fstream.h>
//#include <libc.h>
#include "PAParser.h"

extern int CKparse();
extern FILE *CKin;
extern PARuleBlock *theBlock;
extern void fatal(char *, char *);

int compile_type;
int doDebug;

// char *commandline = NULL;
char *filenameC, *filenameH, *filenameSLC, *filenameMainC, *filenameMainH;

static int myinput(char *buf, int max);

#undef YY_INPUT
#define YY_INPUT(buf, result, max) (result = myinput(buf, max))

%}


%%
[^ \n\t\-\+]+".rb"              { 
                       ofstream foutC, foutH, foutSLC, foutMainC, foutMainH; 

					   // char *temp;
					   int strlength;

					   if((CKin = fopen(CLtext, "rt")) == NULL) {
					     fatal("Unable to open coko rule block file", CLtext);
					   }

					   if(CKparse() == 0) {
						 strlength = strlen(theBlock->Name()) + strlen(".cc") + 1;
						 filenameC = new char[strlength];
						 sprintf(filenameC, "%s.cc", theBlock->Name());

						 strlength = strlen(theBlock->Name()) + strlen(".h") + 1;
						 filenameH = new char[strlength];
						 sprintf(filenameH, "%s.h", theBlock->Name());

						 strlength = strlen(theBlock->Name()) + strlen("_main.cc") + 1;
						 filenameMainC = new char[strlength];
						 sprintf(filenameMainC, "%s_main.cc", theBlock->Name());

						 strlength = strlen(theBlock->Name()) + strlen("_main.h") + 1;
						 filenameMainH = new char[strlength];
						 sprintf(filenameMainH, "%s_main.h", theBlock->Name());

						 strlength = strlen(theBlock->Name()) + strlen("_sl.cc") + 1;
						 filenameSLC = new char[strlength];
						 sprintf(filenameSLC, "%s_sl.cc", theBlock->Name());

						 if (compile_type == 2) // Default compile type
						   {
						     foutC.open(filenameC);
						     foutH.open(filenameH);
						   }
						 /* Removed
						    if (compile_type == 1) // Shared library compile type
						    foutSLC.open(filenameSLC);
						 */
						 if (compile_type == 0) // Executable
						   {
						     foutMainC.open(filenameMainC);
						     foutMainH.open(filenameMainH);
						   }
						 // Summer 2000: Removed prolog support here, and inside Emit()
						 theBlock->Emit(foutH, foutC, foutSLC, foutMainC, foutMainH, compile_type, doDebug);

						 if (compile_type == 2)
						 { 
                                                    foutC.close();
						    foutH.close();
						 }

						 if (compile_type == 1)
						    foutSLC.close();

						 if (compile_type == 0)
						   { 
						     foutMainC.close();
						     foutMainH.close();
						   }

						 delete filenameH;
						 delete filenameSLC;
						 delete filenameC;
						 delete filenameMainC;
						 delete filenameMainH;

						 delete theBlock;
						 theBlock = NULL;
						 filenameC = filenameH = filenameSLC = filenameMainC = filenameMainH = NULL;

					   }
					   else fatal("Parse error in coko rule block file", CLtext);
                     }


[^ \n\t\-\+]+".pr"   { 
  // Summer 2000: Parsing of coko property files

  // Open file...
  if((CKin = fopen(CLtext, "rt")) == NULL) {
    fatal("Unable to open coko property file", CLtext);
  }
  
  // Parse
  CKparse();
  
}


[^ \t\n]+            { 
  fatal("Please give either a coko ruleblock (.rb) or property (.pr) file, not", CLtext);
}

%%
char **targv;
char **arglim;

static unsigned offset = 0;

int
myinput(char *buf, int max)
{
  int len, copylen;
 
  if(targv >= arglim)
	return 0;
  
  len = strlen(*targv) - offset;
  if(len >= max)
	copylen = max - 1;
  else
	copylen = len;
  if(len > 0)
	memcpy(buf, targv[0] + offset, copylen);
  if(targv[0][offset + copylen] == '\0') {
	buf[copylen] = ' ';
	copylen++;
	offset = 0;
	targv++;
  }
  return copylen;
}

int CLwrap() { return 1; }

