//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Marina Zlatkina
//  FILE: NonTypeArgs.H
//  PROJ: COKO
//  DATE: 8/2001                                                            
//
// SYNOPSIS
//  Class to represent the arguments to a property.
//  
//////////////////////////////////////////////////////////////////////////////
#ifndef _NONTYPEARGS_H
#define _NONTYPEARGS_H

#include <NonTypeList.H>
#include <PCPattern.H>
#include <PCState.H>

class NonType;

class NonTypeArgs{

private:
  NonTypeList *list;
  // the list of NonType objects

  int num;
  // number of arguments

  bool success;

public:
  NonTypeArgs( NonTypeList *, int );
  // constructor that creates a NonTypeArgs from a NonTypeList

  NonTypeArgs( int, ... );
  // constructor that creates a NonTypeArgs from a variable number of NonTypes

  NonTypeArgs *build(CState *);
  // substitues all variables in all arguments with their values.

  CState *match(CState *, NonTypeArgs *);
  // matches a pattern NonTypeArgs (current object) with the arguments provided
  // at runtime

  char * representation();
  // returns the character representation of all the arguments

  int numArgs() { return num; }
  // returns the number of arguments this NonTypeArgs contains

  NonTypeList *theList(){ return list; };
  // returns a pointer to the NonTypeList

  void print();
  // prints out the contents of each NonType contained in list.
  // for debugging purposes

  int GetSuccess(){return success;};

  void SetSuccess(bool s ){ success = s;}

};

#endif
