/*
 * Copyright 1994, Brown University, Providence, RI
 *
 * Permission to use and modify this software and its documentation for
 * any purpose other than its incorporation into a commercial product is
 * hereby granted without fee.  Permission to copy and distribute this
 * software and its documentation only for non-commercial use is also
 * granted without fee, provided, however, that the above copyright notice
 * appear in all copies, that both that copyright notice and this permission
 * notice appear in supporting documentation, that the name of Brown
 * University not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission,
 * and that the person doing the distribution notify Brown University of
 * such distributions outside of his or her organization. Brown University
 * makes no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 * Brown University requests notification of any modifications to this
 * software or its documentation.
 *
 * Send the following redistribution information:
 *
 *      Name:
 *      Organization:
 *      Address (postal and/or electronic):
 *
 * To:
 *      Software Librarian
 *      Computer Science Department, Box 1910
 *      Brown University
 *      Providence, RI 02912
 *
 *              or
 *
 *      brusd@cs.brown.edu
 *
 * We will acknowledge all electronic notifications.
 */

/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//
// NAME: Mitch Cherniack (mfc@cs.brown.edu)
//       Joon S. Lee (jl@cs.brown.edu)
// FILE: KOBool.C
// PROJ: COKO Compiler, KOLA Parser
// DATE: 5/97
//
//////////////////////////////////////////////////////////////////////////////

#include "KOBool.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  koBool
// Parameters:	(TBool*, char*)							  
//
// Constructor.
//
//////////////////////////////////////////////////////////////////////////////

koBool::koBool (TBool *t, char * nm)
{
  type = t;

  if (nm == NULL) namestring = NULL;
  else {
    namestring = new char [strlen(nm) + 1];
    sprintf (namestring, "%s", nm);
  }
  variableNum = 0;
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  koBool
// Parameters:	()							  
//
// Copy constructor.
//
//////////////////////////////////////////////////////////////////////////////

koBool::koBool (const koBool& other)
{
  if (other.Type() == NULL) type = NULL;
  else type = new TBool (* (other.Type()));

  namestring = new char [strlen (other.Name()) + 1];
  sprintf (namestring, "%s", other.Name());

  variableNum = other.getVariableNum();
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  ~koBool
// Parameters:	()							  
//
// Destructor.
//
//////////////////////////////////////////////////////////////////////////////

koBool::~koBool ()
{
  delete type;
  delete [] namestring;
}

  
//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  oql
// Parameters:	()
//
//  Return the OQL string equivalent of this object
//         								    
//////////////////////////////////////////////////////////////////////////////

char* koBool::oql ()
{
  char *res = new char [strlen ("ERROR: oql () called on ") + strlen (namestring) + 1];
  sprintf (res, "ERROR: oql () called on %s", namestring);
  return res;
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  sql
// Parameters:	()
//
//  Returns OQL representation of this object
//         								    
//////////////////////////////////////////////////////////////////////////////

char* koBool::sql ()
{
  char *res = new char [strlen ("ERROR: sql () called on ") + strlen (namestring) + 1];
  sprintf (res, "ERROR: sql () called on %s", namestring);
  return res;
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  boo
// Parameters:	()
//
// Symbolic simplification of this.  Eventually,
// this method will replace "bool" presently
// only defined with _OSTORE_ flag set
//  
//////////////////////////////////////////////////////////////////////////////

koBool* koBool::boo ()
{
  return Copy ();
}

