/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc)
//        Xiaoyu Wang (wangxy)
//  FILE: KOTAlt.C 
//  PROJ: COKO, KOLA
//  DATE: 9/00		                                                    
//
//////////////////////////////////////////////////////////////////////////////

#include "KOTAlt.H"
extern "C" { int atio(const char *s); }
  
//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TAlt
// Parameters: (TagExp* te1, TagExp* te2)
//
// Constructor.Initialize one and two with the parameteres
//
/////////////////////////////////////////////////////////////////////////////

TAlt::TAlt(TagExp* te1, TagExp* te2):TagExp( TAGEXP_ALT, "\\|" )
{
    one = te1;
    two = te2;
    variableNum = 0;
}

//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TAlt
// Parameters:(TAlt& other)
//
// Copy Constructor
//
/////////////////////////////////////////////////////////////////////////////

TAlt::TAlt(const TAlt& other):TagExp((TagExp &)other)
{
  one = other.One()->Copy();
  two = other.Two()->Copy();
  variableNum = other.getVariableNum();
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: ~TAlt
// Parameters: ()
//
// Destructor
//
/////////////////////////////////////////////////////////////////////////////

TAlt::~TAlt()
{
  delete one;
  delete two;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: Copy
// Parameters: ()
//
// return the copy of this tagexp
//
/////////////////////////////////////////////////////////////////////////////

TagExp* TAlt::Copy() const
{
  TAlt* temp = new TAlt (*this);
  temp->setVariableNum(variableNum);
  return temp;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: deepeq
// Parameters: (NonType *)
//
// does nothing
//
/////////////////////////////////////////////////////////////////////////////

int TAlt::deepeq(NonType* other)
{
  return T;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: Myname
// Parameters: ()
//
// does nothing 
//
////////////////////////////////////////////////////////////////////////////

NameUnion* TAlt::Myname()
{
  return NULL;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name:  nextChild
// Parameters: ()
//
// Return "currChild++"th child.
// When currChild is equal to the number of children
// (when currChild is the last child), it returns NULL.
//
/////////////////////////////////////////////////////////////////////////////

NonType* TAlt::nextChild()
{
  if(currChild == 0){
    currChild++;
    return one;
  } else { 
    if(currChild == 1){
    currChild++;
    return two;
    }else 
      return NULL;
  }
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: representation
// Parameters: ()
//
//  pr1 " ALT " pr2
//
/////////////////////////////////////////////////////////////////////////////

char * TAlt::representation()
{
    char *pr1 = one->representation();
    char *pr2 = two->representation();

    char *res = new char[strlen(pr1)+strlen(pr2)+strlen("() \\| ()")+1];
    sprintf(res, "(%s) \\| (%s)", pr1, pr2);
    delete [] pr1;
    delete [] pr2;
    return res;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: transform
// Parameters: (CState*)
//
// Return corresponding NonType object.
//
////////////////////////////////////////////////////////////////////////////

NonType* TAlt::transform(CState* s)
{
    return this;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: compares
// Parameters: (NonType*, CState*)
//
// compare two trees
//
////////////////////////////////////////////////////////////////////////////

int TAlt::compares(NonType* nt, CState* a)
{
    return T;
}

//////////////////////////////////////////////////////////////////////////
//
// Function Name: compareSTM
// Parameter: (NonType*, CState*)
//
// Check for match between two NonType tree...
//
// Does nothing now, just return T, 
//
//////////////////////////////////////////////////////////////////////////

int TAlt::compareSTM(NonType* nt, CState* a)
{
    return T;
}

///////////////////////////////////////////////////////////////////////////
//
// Function Name: replaceChild
// Parameters: (NonType*, int)
//
// Replace a child of a given tree..
//
///////////////////////////////////////////////////////////////////////////

void TAlt::replaceChild(NonType* child, int which_child)
{
  if(which_child == 1)
    setOne(child);
  else if(which_child == 2)
    setTwo(child);
}


///////////////////////////////////////////////////////////////////////////
//
// Function Name: prolog
// Parameters:()
//
//////////////////////////////////////////////////////////////////////////

char* TAlt::prolog()
{
  return NULL;
}

#ifdef _PROLOG_
///////////////////////////////////////////////////////////////////////////
//
// Function Name: sp_prolog
// Parameters:()
//
// Does nothing, return NULL
//
///////////////////////////////////////////////////////////////////////////

SP_term_ref TAlt::sp_prolog()
{
    return NULL;
}
#endif //_PROLOG_

