
/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc)
//        Xiaoyu Wang (wangxy)
//  FILE: KOTTilde.C 
//  PROJ: COKO, KOLA
//  DATE: 9/00		                                                    
//
//////////////////////////////////////////////////////////////////////////////

#include "KOTTilde.H"
extern "C" { int atio(const char *s); }
  
//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TTilde
// Parameters: (Tag* tg)
//
// Constructor.
//
/////////////////////////////////////////////////////////////////////////////

TTilde::TTilde(Tag* tg):TagExp(TAGEXP_TILDE, "~" )
{
    one = tg;
    variableNum = 0;
}

//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  Tilde
// Parameters:(TTilde& other)
//
// Copy Constructor
//
/////////////////////////////////////////////////////////////////////////////

TTilde::TTilde(const TTilde& other):TagExp((TagExp &)other)
{
    one = other.One()->Copy();
    variableNum = other.getVariableNum();
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: ~TTilde
// Parameters: ()
//
// Destructor
//
/////////////////////////////////////////////////////////////////////////////

TTilde::~TTilde()
{
    delete one;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: Copy
// Parameters: ()
//
// return the copy of this tagexp
//
/////////////////////////////////////////////////////////////////////////////

TagExp* TTilde::Copy() const
{
  TTilde* temp = new TTilde (*this);
  temp->setVariableNum(variableNum);
  return temp;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: deepeq
// Parameters: (NonType *)
//
// does nothing now.
//
/////////////////////////////////////////////////////////////////////////////

int TTilde::deepeq(NonType* other)
{
  return T;

}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: Myname
// Parameters: ()
//
// return null
//
////////////////////////////////////////////////////////////////////////////

NameUnion* TTilde::Myname()
{
  return NULL;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name:  nextChild
// Parameters: ()
//
// Return "currChild++"th child.
// When currChild is equal to the number of children
// (when currChild is the last child), it returns NULL.
//
/////////////////////////////////////////////////////////////////////////////

NonType* TTilde::nextChild()
{
    if(currChild == 0)
      {
        currChild++;
        return one;
      }
    else  return NULL;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: representation
// Parameters: ()
//
/////////////////////////////////////////////////////////////////////////////

char * TTilde::representation()
{
  char *pr = one->representation();
  char *res = new char[strlen(pr)+strlen("~ ")+1];
  sprintf(res, "~ %s", pr);
  delete [] pr;
  return res;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: Transform
// Parameters: (CState*)
//
// Return corresponding NonType object.
//
// Now it does nothing just return itself 
//
////////////////////////////////////////////////////////////////////////////

NonType* TTilde::Transform(CState* s)
{
    return this;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: compares
// Parameters: (NonType*, CState*)
//
// compare two trees, refine later
//
////////////////////////////////////////////////////////////////////////////

int TTilde::compares(NonType* nt, CState* a)
{
  return T;
}

//////////////////////////////////////////////////////////////////////////
//
// Function Name: compareSTM
// Parameter: (NonType*, CState*)
//
// Check for match between two NonType tree...
// Does nothing now, just return T, 
//
//////////////////////////////////////////////////////////////////////////

int TTilde::compareSTM(NonType* nt, CState* a)
{
  return T;
}

///////////////////////////////////////////////////////////////////////////
//
// Function Name: undoSetInvDEP
//
// Parameters: (char *, CState*)
//
// Undo the changes.
//
///////////////////////////////////////////////////////////////////////////

void TTilde::undoSetInvDEP(char* vn, CState* s)
{
    one->undoSetInvDEP(vn, s);
}

///////////////////////////////////////////////////////////////////////////
//
// Function Name: replaceChild
// Parameters: (NonType*, int)
//
// Replace a child of a given tree..
//
///////////////////////////////////////////////////////////////////////////

void TTilde::replaceChild(NonType* child, int which_child)
{
  if(which_child == 1)
      setOne(child);
}

///////////////////////////////////////////////////////////////////////////
//
// Function Name: prolog
// Parameters:()
//
// Does nothing, return NULL
//
//////////////////////////////////////////////////////////////////////////

char* TTilde::prolog()
{
  return NULL;
}

#ifdef _PROLOG_
///////////////////////////////////////////////////////////////////////////
//
// Function Name: sp_prolog
// Parameters:()
//
// Does nothing, return NULL
//
///////////////////////////////////////////////////////////////////////////

SP_term_ref TTilde::sp_prolog()
{
  return NULL;
}
#endif //_PROLOG_

