/* -*-Mode:c++-*- */


/*
 * Copyright 1994, Brown University, Providence, RI
 *
 * Permission to use and modify this software and its documentation for
 * any purpose other than its incorporation into a commercial product is
 * hereby granted without fee.  Permission to copy and distribute this
 * software and its documentation only for non-commercial use is also
 * granted without fee, provided, however, that the above copyright notice
 * appear in all copies, that both that copyright notice and this permission
 * notice appear in supporting documentation, that the name of Brown
 * University not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission,
 * and that the person doing the distribution notify Brown University of
 * such distributions outside of his or her organization. Brown University
 * makes no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 * Brown University requests notification of any modifications to this
 * software or its documentation.
 *
 * Send the following redistribution information:
 *
 *	Name:
 *	Organization:
 *	Address (postal and/or electronic):
 *
 * To:
 *	Software Librarian
 *	Computer Science Department, Box 1910
 *	Brown University
 *	Providence, RI 02912
 *
 *		or
 *
 *	brusd@cs.brown.edu
 *
 * We will acknowledge all electronic notifications.
 */

//////////////////////////////////////////////////////////////////////////////
//
// NAME: Mitch Cherniack (mfc@cs.brown.edu)
// FILE: QLParser.H
// PROJ: QLite -> KOLA Translator
// DATE: 7/98
//
//////////////////////////////////////////////////////////////////////////////

#ifndef QLPARSER_H
#define QLPARSER_H

#include <stdio.h>
#include <iostream.h>
#include "KGlobals.H"
#include "KONonType.H"
#include "KOObject.H"
#include "KOBool.H"


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// CLASS QLParser
//
// Class of parser objects that reads a query from a string at time of
// construction, and for which the method parse, constructs a KOLA tree
// corresponding to the query.
//         								    
//////////////////////////////////////////////////////////////////////////////

class QLParser
{
private:
  FILE *inp;

public:

  QLParser (char *f);                   // Constructor.
  ~QLParser ();

  NonType *parse ();      
      // Parse the current file, returning the resulting KOLA tree

  void setInput (char *f);
      // Change the file currently associated with the parser
};

#endif


